use bcrypt;
use rocket::form::Form;
use super::db_wrapper;
use db_wrapper::schemas::User;

#[derive(FromForm)]
pub struct UserAuth<'r> {
    username: &'r str,
    password: &'r str
}

#[get("/")]
pub fn index() -> &'static str {
    "Auth!"
}


#[post("/login", data = "<user>")]
pub async fn login(user: Form<UserAuth<'_>>) -> String {
    let users = db_wrapper::get_client().await.collection::<User>("users");
    let hashed = bcrypt::hash(&user.password, bcrypt::DEFAULT_COST).unwrap();

    let insert_user = User {
        username: user.username.to_string(),
        pwd_hash: hashed.to_string()
    };

    match users.insert_one(insert_user, None).await {
        Err(e) => format!("Error encountered while inserting user.\nERROR: {}", e),
        Ok(_) => format!("Hello {}! Your password is {}. Your hash is `{}`", user.username, user.password, hashed)
    }
}