#[macro_use] extern crate rocket;

mod db_wrapper;
mod auth;

#[get("/")]
fn index() -> &'static str {
    "Hello, world!"
}

#[rocket::main]
async fn main() {
    let rocket = rocket::build()
        .mount("/", routes![index])
        .mount("/auth", routes![auth::index, auth::login])
        .launch()
        .await;

    match rocket {
        Err(e) => println!("There seems to be an error with rocket!\n{:?}", e),
        _ => ()
    }
}
